/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_EXCEPTION_INL
#define __TOOLBOX_EXCEPTION_INL


// --- Class Exception ---

inline const char * Exception::GetClassName()
{
	ASSERTION_THIS;
	return ClassName;
}

inline long Exception::GetLineNumber()
{
	ASSERTION_THIS;
	return LineNumber;
}

inline const char * Exception::GetMessage()
{
	ASSERTION_THIS;
	return Message;
}

inline const char * Exception::GetSource()
{
	ASSERTION_THIS;
	return Source;
}


// --- Class EDeviceError ---

#ifdef _WINDOWS
	inline String EDeviceError::GetLastErrorMessage()
	{
		return EDeviceError::GetErrorMessage(::GetLastError());
	}
#endif


// --- Class EOutOfMemory ---

inline EOutOfMemory * EOutOfMemory::Get()
{
	return &Singleton;
}


#endif
