/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_GRAPH_INL
#define __TOOLBOX_GRAPH_INL


// --- Class Edge ---

inline void * Edge::GetData()
{
	ASSERTION_THIS;
	return Data;
}

inline Vertex * Edge::GetFromVertex()
{
	ASSERTION_THIS;
	return FromVertex;
}

inline Vertex * Edge::GetToVertex()
{
	ASSERTION_THIS;
	return ToVertex;
}

inline void Edge::SetData(void * data)
{
	ASSERTION_THIS;
	Data = data;
}


// --- Class EdgeArray ---

inline class Edge * EdgeArray::Get(long nr)
{
	ASSERTION_THIS;
	return ArrayList<Edge>::Get(nr);
}

inline long EdgeArray::GetCount()
{
	ASSERTION_THIS;
	return ArrayList<Edge>::GetCount();
}

inline bool EdgeArray::IsEmpty()
{
	ASSERTION_THIS;
	return ArrayList<Edge>::IsEmpty();
}


// --- Class Graph ---

inline bool Graph::DeleteEdge(class Edge * Edge)
{
	ASSERTION_THIS;
	return Edges->Delete(Edge);
}

inline void Graph::DeleteEdges()
{
	ASSERTION_THIS;
	Edges->DeleteAll();
}

inline bool Graph::DeleteVertex(class Vertex * Vertex)
{
	ASSERTION_THIS;
	return Vertices->Delete(Vertex);
}

inline void Graph::DeleteVertices()
{
	ASSERTION_THIS;
	Vertices->DeleteAll();
}

inline EdgeArray * Graph::GetEdges()
{
	ASSERTION_THIS;
	return Edges;
}

inline VertexArray * Graph::GetVertices()
{
	ASSERTION_THIS;
	return Vertices;
}


// --- Class Vertex ---

inline bool Vertex::DeleteEdge(class Edge * Edge)
{
	ASSERTION_THIS;
	return Edges->Delete(Edge);
}

inline void Vertex::DeleteEdges()
{
	ASSERTION_THIS;
	Edges->DeleteAll();
}

inline void * Vertex::GetData()
{
	ASSERTION_THIS;
	return Data;
}

inline EdgeArray * Vertex::GetEdges()
{
	ASSERTION_THIS;
	return Edges;
}

inline void Vertex::SetData(void * data)
{
	ASSERTION_THIS;
	Data = data;
}

inline class Vertex * VertexArray::Get(long nr)
{
	ASSERTION_THIS;
	return ArrayList<Vertex>::Get(nr);
}


// --- Class VertexArray ---

inline long VertexArray::GetCount()
{
	ASSERTION_THIS;
	return ArrayList<Vertex>::GetCount();
}

inline bool VertexArray::IsEmpty()
{
	ASSERTION_THIS;
	return ArrayList<Vertex>::IsEmpty();
}


#endif
