/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_MD5HASHER_H
#define __TOOLBOX_MD5HASHER_H


#define _TB_MD5HASHER_RL(x, n) (((x) << (n)) | ((x) >> (32 - (n))))

#define _TB_MD5HASHER_F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define _TB_MD5HASHER_G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define _TB_MD5HASHER_H(x, y, z) ((x) ^ (y) ^ (z))
#define _TB_MD5HASHER_I(x, y, z) ((y) ^ ((x) | (~z)))

#define _TB_MD5HASHER_FF(a, b, c, d, x, s, ac) \
	{ \
		(a) += _TB_MD5HASHER_F ((b), (c), (d)) + (x) + (unsigned long) (ac); \
		(a) = _TB_MD5HASHER_RL ((a), (s)); \
		(a) += (b); \
	}

#define _TB_MD5HASHER_GG(a, b, c, d, x, s, ac) \
	{ \
		(a) += _TB_MD5HASHER_G ((b), (c), (d)) + (x) + (unsigned long) (ac); \
		(a) = _TB_MD5HASHER_RL ((a), (s)); \
		(a) += (b); \
	}

#define _TB_MD5HASHER_HH(a, b, c, d, x, s, ac) \
	{ \
		(a) += _TB_MD5HASHER_H ((b), (c), (d)) + (x) + (unsigned long) (ac); \
		(a) = _TB_MD5HASHER_RL ((a), (s)); \
		(a) += (b); \
	}

#define _TB_MD5HASHER_II(a, b, c, d, x, s, ac) \
	{ \
		(a) += _TB_MD5HASHER_I ((b), (c), (d)) + (x) + (unsigned long) (ac); \
		(a) = _TB_MD5HASHER_RL ((a), (s)); \
		(a) += (b); \
	}


namespace toolbox
{
	class MD5Hasher
	{
		private:

			static const unsigned char PADDING[64];

			unsigned char buffer[64];
			unsigned long count1;
			unsigned long count2;
			unsigned long state[4];

			void reset();
			inline void transform(unsigned long * newState);

		public:

			MD5Hasher();
			void finalize(unsigned char * digest);
			inline void hash(unsigned char number);
			inline void hash(unsigned int number);
			inline void hash(unsigned long number);
			void hash(const unsigned char * data, int length);
	};
}


#endif
