/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_SIMULATION_INL
#define __TOOLBOX_SIMULATION_INL


// --- Class Simulation ---

inline void Simulation::End()
{
	ASSERTION_THIS;
	HasEndedFlag = true;
}

inline long Simulation::GetClock()
{
	ASSERTION_THIS;
	return Clock;
}

inline long Simulation::GetEventCount()
{
	ASSERTION_THIS;
	return Events->GetCount();
}

inline long Simulation::GetObjectCount()
{
	ASSERTION_THIS;
	return Objects->GetCount();
}

inline bool Simulation::HasEnded()
{
	ASSERTION_THIS;
	return HasEndedFlag;
}


// --- Class SimulationEvent ---

inline Simulation * SimulationEvent::GetSimulation()
{
	ASSERTION_THIS;
	return Simulation;
}

inline long SimulationEvent::GetTime()
{
	ASSERTION_THIS;
	return Time;
}


// --- Class SimulationObject ---

inline Simulation * SimulationObject::GetSimulation()
{
	ASSERTION_THIS;
	return Simulation;
}


#endif
