/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_TESTOBJECT_H
#define __TOOLBOX_TESTOBJECT_H


namespace toolbox
{
	/**
	 * A test class for the RunTestSuite methods
	 * of all ToolBox classes.
	 * @author Thomas Jacob
	 */
	class TestListObject : public ContainingListItem<TestListObject>
	{
		private:

			/**
			 * The number of existing instances of this class (for testing purposes).
			 */
			static int InstanceCount;

		public:

			/**
			 * Constructs the object.
			 */
			TestListObject();

			/**
			 * Destroys the object.
			 */
			~TestListObject();

			/**
			 * Getter method.
			 * @return The number of existing instances of this class.
			 */
			static inline int GetInstanceCount();

			/**
			 * A number.
			 */
			int Number;
	};


	/**
	 * A test class for the RunTestSuite methods
	 * of all ToolBox classes.
	 * @author Thomas Jacob
	 */
	class TestObject
	{
		private:

			/**
			 * The number of existing instances of this class (for testing purposes).
			 */
			static int InstanceCount;

		public:

			/**
			 * Constructs the object.
			 */
			TestObject();

			/**
			 * Destroys the object.
			 */
			~TestObject();

			/**
			 * Getter method.
			 * @return The number of existing instances of this class.
			 */
			static inline int GetInstanceCount();

			/**
			 * A number.
			 */
			int Number;
	};


	/**
	 * A test class for the RunTestSuite methods
	 * of all ToolBox classes.
	 * @author Thomas Jacob
	 */
	class TestStackObject : public ContainingStackItem<TestStackObject>
	{
		private:

			/**
			 * The number of existing instances of this class (for testing purposes).
			 */
			static int InstanceCount;

		public:

			/**
			 * Constructs the object.
			 */
			TestStackObject();

			/**
			 * Destroys the object.
			 */
			~TestStackObject();

			/**
			 * Getter method.
			 * @return The number of existing instances of this class.
			 */
			static inline int GetInstanceCount();

			/**
			 * A number.
			 */
			int Number;
	};
}


#endif
